//****************************************************************
//  Audit Trail Report                         G. Danen  08-Nov-98
//
//  Copyright (c) 1995-1999 by GeCe Ventures; all rights reserved.
//
//  Requires MBBS developers kit to recompile
//****************************************************************


#include"gcomm.h"
#include"majorbbs.h"
#include"message.h"
#include"danenlib.h"


#define pgVERS_ "V3.10"
#define pgTITL_ "Audit Trail Listing for The Major BBS/WorldGroup"
#define pgCOPR_ "1995-1999"
#define inHOUSEuse  0


int     done = 0 ;                              // are we done?
int     outFormat = 1 ;                         // 1=Std, 2=Long, 3=User
int     verbose = 0 ;                           // 1=include non-recognized records
int     noSysOp = 0 ;                           // 1=omit SysOp data
long    finish,                                 // end of search within BTRIEVE file (post)
        found=0 ;                               // # recs found

char    outFile[256]="auditrep.out", inFile[256]="bbsaudit.dat" ;
FILE    *fOut ;

char    datnone[9]="000000",                    // start date
        datntwo[9]="999999",                    // ending date in 010180 format
        audrec[AUDSIZ],                         // Auditrail input line
        work[AUDSIZ+100] ;                      // work area
char    *Line = "" ;

BTVFILE *btvAud ;                               // btrieve file pointer
BTVFILE *genbb  ;                               // generic user data file btrieve file ptr - don't change name "genbb"


#include"danenlib.c"


//~~~
void    syntax( void )
{
    fprintf( stderr, "\nPossible parameters:\n\n"
                     "\t/i=inputfile    use if data file is not BBSAUDIT.DAT (e.g., a\n\t\t\tpreviously backed up file)\n"
                     "\t/o=outputfile   use if output should not be the default AUDITREP.OUT\n"
                     "\t/long           puts all data on a single long line\n"
                     "\t/user           produces the user-activity report\n"
                     "\t/v              verbose mode (used with /u)\n"
                     "\t/nosysop        omit SysOp information (used with /u)\n" );
    exit(1);
}


void    norecs(void)
{
    fprintf( fOut, "** No Data in Audit Trail **\n" );
}


void    unravel_ul_dl( char u[], char r[] )
{
    char        *p ;

    if ( strnicmp( &r[59], "User ", 5 ) )
        return ;

//            15
//0423 0056 | LIBRARY FILE DOWNLOAD            Chan 01    User Lds download LIBCOPY\DATABASE.X01
//0423 0130 | LIBRARY FILE DOWNLOAD ABORTED    Chan 01    User Tony Duthler aborted dnld of VIRUS\FP-217.ZIP

//0423 0056 | d/l : LIBCOPY\DATABASE.X01
//0423 0130 | d/l*: VIRUS\FP-217.ZIP

    if ( ! strnicmp( &r[28], "DOWNLOAD ABORTED", 16 ) )
    {
        p = strstr( &r[64], "aborted dnld of" );
        if ( p )
        {
            p-- ;
            *p = EOS ;
            st_cpy( u, &r[64], UIDSIZ );
            *p = ' ' ;
            p = strrchr( &r[64], ' ' );
            strupr( p );
            sprintf( &r[15], "d/l*:%s", p );
        }
        return ;
    }
    if ( ! strnicmp( &r[28], "UPLOAD ABORTED", 14 ) )
    {
        p = strstr( &r[64], "aborted upld of" );
        if ( p )
        {
            p-- ;
            *p = EOS ;
            st_cpy( u, &r[64], UIDSIZ );
            *p = ' ' ;
            p = strrchr( &r[64], ' ' );
            strupr( p );
            sprintf( &r[15], "u/l*:%s", p );
        }
        return ;
    }
    if ( ! strnicmp( &r[28], "DOWNLOAD  ", 10 ) )
    {
        p = strstr( &r[64], "download " );
        if ( p )
        {
            p-- ;
            *p = EOS ;
            st_cpy( u, &r[64], UIDSIZ );
            *p = ' ' ;
            p = strrchr( &r[64], ' ' );
            strlwr( p );
            sprintf( &r[15], "d/l :%s", p );
        }
        return ;
    }
    if ( ! strnicmp( &r[28], "UPLOAD  ", 8 ) )
    {
        p = strstr( &r[64], "uploaded " );
        if ( p )
        {
            p-- ;
            *p = EOS ;
            st_cpy( u, &r[64], UIDSIZ );
            *p = ' ' ;
            p = strrchr( &r[64], ' ' );
            strlwr( p );
            sprintf( &r[15], "u/l :%s", p );
        }
        return ;
    }
}


void    do_user_record( char r[] )
{
    static char newrec[sizeof(work)], *p, *century, uid[UIDSIZ+128] ;

    //  bypass records we don't want
    if ( ! strnicmp( &r[15], "BBS UP: V", 9 ) )
        return ;
    if ( ! strnicmp( &r[15], "BBS SHUTDOWN", 12 ) )
        return ;
    if ( ! strnicmp( &r[15], "SYSTEM USAGE SINCE LAST CLEANUP", 31 ) )
        return ;
    if ( ! strnicmp( &r[59], "Registration #", 14 ) )
        return ;

//~~~

    uid[0] = EOS ;
    if ( r[12] == '9' || r[12] == '8' )
        century = "19" ;
    else
        century = "20" ;
    r[2] = r[5] = r[8] = r[11] = r[14] = EOS ;

    if ( ! strnicmp( &r[59], "New User-ID:", 12 ) )
    {
        ST_CPY( uid, &r[72] );
        if ( ! strnicmp( &r[15], "new user signup", 15 ) )
            r[48] = EOS ;
        st_trim( &r[15] );
        strlwr ( &r[15] );
    }
    if ( ! strnicmp( &r[59], "User-ID:", 8 ) )
    {
        ST_CPY( uid, &r[68] );
        if ( ! strnicmp( &r[15], "user logoff", 11 ) )
            r[15] = r[16] = r[17] = r[18] = ' ' ;
        if ( ! strnicmp( &r[15], "user logon", 10 ) )
            r[15] = r[16] = r[17] = r[18] = ' ' ;
        r[48] = EOS ;
        st_trim( &r[15] );
        strlwr ( &r[15] );
    }
    if ( ! strnicmp( &r[15], "library file", 12 ) )
        unravel_ul_dl( uid, r );

    if ( ! strnicmp( &r[15], "DAILY TOP USER", 14 ) )
    {
        p = strstr( &r[59], "online for " );
        if ( p )
        {
            p-- ;
            *p = EOS ;
            ST_CPY( uid, &r[59] );
            *p = ' ' ;
            p = strstr( &r[59], "online for " );
            p = strstr( p, "for " );
            p = strstr( p, " " );
            sprintf( &r[15], "top user: %s", ++p );
        }
    }

    if ( ! strnicmp( &r[15], "PPP SERVER SESSION ENDED", 24 ) )
    {
        p = strstr( &r[59], ", " );
        if ( p )
        {
            *p = EOS ;
            ST_CPY( uid, &r[59] );
            strcpy( &r[15], "logoff from PPP" );
        }
    }
    if ( ! strnicmp( &r[15], "LOGON DIRECT TO PPP", 19 ) )
    {
        p = strstr( uid, ", " );
        if ( p )
        {
            *p = EOS ;
            p ++ ;
            st_trim( p );
            sprintf( &r[15], "logon at %s to PPP", p );
        }
        else
            sprintf( &r[15], "logon to PPP" );
    }
//~~~
//20:03 11/23/96 USER LOGON DIRECT TO PPP         Chan 20     User-ID: Pei Wu, 28800 bps

    if ( ! strnicmp( &r[15], "INVALID PASSWORD ATTEMPT", 24 ) )
    {
        p = strstr( &r[59], " attempt on \"" );
        if ( p )
        {
            *p = EOS ;
            ST_CPY( uid, &r[59] );
            *p = ' ' ;
            p = strstr( &r[59], "\"" );
            ST_CPY( uid, ++p );
            st_trim( uid );
            ST_CLR_LASTCHAR(uid);
            p = strstr( &r[59], " attempt on \"" );
            *p = EOS ;
            sprintf( &r[15], "INVALID PASSWORD: %s", &r[59] );
        }
    }

//  5  8  11  15
//??**        FORUM ATTACHMENT DOWNLOAD        Chan 01    Ben Chan downld 714.ATT from /Hello
//??**        FORUM ATTACHMENT DOWNLOAD        Chan 04    Sysop downld 714.ATT from /Hello
//??**        FORUM ATTACHMENT UPLOAD          Chan 04    Sysop uploaded 714.ATT to /Hello

    st_trim( uid );
    if ( (! strlen(uid)) && verbose )
        strcpy( uid, "** ?? **" );
    sprintf( newrec, "%-*.*s %s%s%s%s %s%s", UIDSIZ, UIDSIZ, uid, century, &r[12], &r[6], &r[9], &r[0], &r[3] );
    st_trim( &r[15] );
    if ( strlen(uid) )
    {
        if ( noSysOp && st_eq("Sysop", uid) )
            return ;
        fprintf( fOut, "%s %s\n", newrec, &r[15] );
    }
}


void    do_audit_trail_dump( void )     //~~~   // do the audit trail report
{
    int acqb=0, acqe=0 ;

    finish = found = 0L ;
    done = 0 ;

    btvAud = opnbtv( inFile, AUDSIZ );
    if ( qlebtv(datntwo,0) )
    {
        acqb = 1 ;
        finish = absbtv();
    }

    acqe = qgebtv( datnone, 0 );
    if ( acqb == 0 || acqe == 0 )
    {
        norecs();
        return;
    }

    do  {
        gcrbtv( audrec, 0 );
        show_activity( found++, 15 );

        switch ( outFormat )
        {
            case 2 :                            // long
                fprintf( fOut, "%14.14s %-32.32s %-10.10s %s\n",
                         audrec, &audrec[14], &audrec[47], &audrec[67] );
                break ;
            case 3 :                            // user
                sprintf( work, "%14.14s %-32.32s %-10.10s %s",
                         audrec, &audrec[14], &audrec[47], &audrec[67] );
                do_user_record( work );
                break ;
            case 1 :
            default:                            // standard
                fprintf( fOut, "%14.14s %-32.32s %s\n     %s\n",
                         audrec, &audrec[14], &audrec[47], &audrec[67] );
                break ;
        }

        if ( finish == absbtv() )
            done = 1 ;
        acqe = qnxbtv();
        if ( acqe == 0 )
            done = 1 ;
    }   while ( ! done );

    fprintf( stderr, "\r%ld records\n", found );
    clsbtv( btvAud );
    if ( ! found )
        norecs();
}


void    main( int argc, char *argv[] )          //~~~ main
{
    int         iArg ;
    char        sArg[256] ;
    BOOL        aborting = FALSE ;

    fprintf( stderr, "\n\r%-72s %s \nCopyright %s by GeCe Ventures, "
                     "all rights reserved.\n%79.79s\n",
                     pgTITL_, pgVERS_, pgCOPR_, Line );

    LOOP( iArg, 1, argc-1, 1 )                  // process arguments
    {
        strcpy( sArg, argv[iArg] );
        strupr( sArg );
        if ( sArg[0] == '/' || sArg[0] == '-' )
        {
            switch ( sArg[1] )
            {
                case 'I' :
                    if ( sArg[2] == '=' && ! (sArg[3] == EOS) )
                    {
                        strcpy( inFile, &sArg[3] );
                    }
                    else
                    {
                        fprintf( stderr, "Invalid syntax for /I parameter\n" );
                        aborting = TRUE ;
                    }
                    break ;
                case 'O' :
                    if ( sArg[2] == '=' && ! (sArg[3] == EOS) )
                    {
                        strcpy( outFile, &sArg[3] );
                    }
                    else
                    {
                        fprintf( stderr, "Invalid syntax for /O parameter\n" );
                        aborting = TRUE ;
                    }
                    break ;
                case 'L' :                      // long format
                    outFormat = 2 ;
                    break ;
                case 'U' :                      // user format
                    outFormat = 3 ;
                    break ;
                case 'V' :                      // verbose mode
                    verbose = 1 ;
                    break ;
                case 'N' :                      // no SysOp stuff
                    noSysOp = 1 ;
                    break ;
                case '?' :
                case 'H' :
                    syntax();
                    break ;
                default :
                    fprintf( stderr, "Invalid argument: \"%s\"\n", sArg );
                    aborting = TRUE ;
                    break ;
            }
        }
        else
            syntax();
    }
    if ( aborting )
    {
        fprintf( stderr, "Use /? for a help message\n" );
        exit(2);
    }

    if (setjmp(disaster))
        exit(1);

    strupr(  inFile );
    strupr( outFile );

    fOut = fopen( outFile, "w" );
    if ( ! fOut )
    {
        fprintf( stderr, "Could not open %s for output\n", outFile );
        exit( 3 );
    }

    fprintf( stderr, "Processing from: %s\n\t     to: %s\n\t   mode: ", inFile, outFile );
    switch ( outFormat )
    {
        case 2 :
            fprintf( stderr, "Long\n" );
            break ;
        case 3 :
            fprintf( stderr, "User Activity\n" );
            break ;
        case 1 :
        default:
            fprintf( stderr, "Standard\n" );
            break ;
    }

    do_audit_trail_dump();

    closing_comments();
    fclose( fOut );
    exit(0);
}
