
typedef char *          STRING ;                // string pointer
typedef signed int      BOOL ;                  // fast integer for TRUE/FALSE and OK/-1

#define FOREVER         for (;;)
#define LOOP(var,from,to,incr)  for ( (var)=(from) ; (var) <= (to) ; (var)=(var)+(incr) )

#define TRUE            (1)
#define FALSE           (0)
#define YES             TRUE
#define NO              FALSE
#define ON              TRUE
#define OFF             FALSE

#define ERROR           (-1)
#define ABORTED         (-2)
#define NO_ERROR        0
#define OK              0                       // for functions returning a 0 to indicate OK status
#define GOOD_EXIT       0                       // standard exit() code: everything is OK
#define BAD_EXIT        1                       // standard exit() code: problems
#define EOS             '\0'                    // end of string

#define STR_LEN         (256)                   // standard string length
#define FS_LEN          260                     // in NetWare longer than DOS

#define BYTE2WORD(h,l)  ((h << 8) | (l & 0x00ff))  // Stuff 2 bytes in a word
#define LOBYTE(a)       (a & 0x00ff)            // Get low byte from word
#define HIBYTE(a)       ((a >> 8) & 0x00ff)     // Get high byte from word
#define INRANGE(n,l,h)  ((n >= l) && (n <= h))  // number, low, high
#define OUTRANGE(n,l,h) ((n < l) || (n > h))    // number, low, high
#define ISBITSET(n,wrd) ((wrd >> n) & ~(~0 << 1))  // is bit 'n' set?
#define CLR_BLOCK(b)    (memset(&b,0,sizeof(b))) // clear a structure/block
                                                // UCHAR version of toupper
#define UP_UCHAR(_c)    ((unsigned char) ( (islower((unsigned char)_c)) ? ((unsigned char)(((unsigned char)_c)-((unsigned char)'a')+((unsigned char)'A'))) : ((unsigned char)(_c)) ))
#define ST_CPY(t_,s_)   st_cpy(t_,(STRING)s_,sizeof(t_))
#define ST_CAT(t_,s_)   st_cat(t_,s_,sizeof(t_))
#define ST_ZERO(t_)     memset(t_,EOS,sizeof(t_))
#define ST_MOVE(dest,src,cnt)   {memset(dest,EOS,(cnt+1));memmove(dest,src,cnt);}
#define ST_CLR(s)       (s[0]='\0')             // clear a string
#define ST_LASTCHAR(s)  (s[strlen(s)-1])        // get last char in string
#define ST_CLR_LASTCHAR(s) (s[strlen(s)-1]='\0') // set last char in string to EOS


//      function prototypes

int     DateSplit(long indate,int *yyyy,int *mm,int *dd);
int     IsLeapYear(int year);
int     fl_parse_ini(STRING sFile,STRING sHeader,STRING sField,STRING sContent,int *iRecNo);
